%define debug_package %{nil}
%undefine _auto_set_build_flags

%global efidir %(eval echo $(grep ^ID= /etc/os-release | sed  's/^ID=//'))
%ifarch x86_64
%global efiarch x86_64
%endif
%ifarch aarch64
%global efiarch aarch64
%endif
%ifarch loongarch64
%global efiarch loongarch64
%endif


Summary:         Development Libraries and headers for EFI
Name:            gnu-efi
Version:         3.0.17
Release:         3%{?dist}
License:         BSD
URL:             https://sourceforge.net/projects/gnu-efi
Source0:         https://sourceforge.net/projects/gnu-efi/files/%{name}-%{version}.tar.bz2
Patch5000:       0001-gnu-efi-3.0.17-add-support-for-loongarch64.patch
Patch5001:       0001-gnu-efi-3.0.17-fix-loongarch64-build-error-problem.patch

BuildRequires:   gcc make binutils sed efi-srpm-macros 
Provides:        %{name}-utils = %{version}-%{release}
Obsoletes:       %{name}-utils < 3.0.17
Obsoletes:       %{name}-compat < 3.0.17

%description
This package contains development headers and libraries for developing
applications that run under EFI (Extensible Firmware Interface).


%package devel
Summary:         Development Libraries and headers for EFI
Requires:        %{name} = %{version}-%{release}
Obsoletes:       %{name} < 3.0.17
Conflicts:       %{name}-compat < 3.0.17

%description devel
This package contains development headers and libraries for developing
applications that run under EFI (Extensible Firmware Interface).


%prep
%autosetup -n %{name}-%{version} -p1


%build
make
make apps
%ifarch x86_64
setarch linux32 -B make ARCH=ia32 PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib
setarch linux32 -B make ARCH=ia32 PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib apps
%endif


%install
install -d %{buildroot}/%{_libdir}/gnuefi
install -d %{buildroot}/boot/efi/EFI/%{efidir}/%{efiarch}
make PREFIX=%{_prefix} LIBDIR=%{_libdir} INSTALLROOT=%{buildroot} install
mv %{buildroot}/%{_libdir}/*.lds %{buildroot}/%{_libdir}/*.o %{buildroot}/%{_libdir}/gnuefi
mv %{efiarch}/apps/{route80h.efi,modelist.efi} %{buildroot}/boot/efi/EFI/%{efidir}/%{efiarch}/

%ifarch x86_64
install -d %{buildroot}/%{_prefix}/lib/gnuefi
install -d %{buildroot}/boot/efi/EFI/%{efidir}/ia32

setarch linux32 -B make PREFIX=%{_prefix} LIBDIR=%{_prefix}/lib INSTALLROOT=%{buildroot} ARCH=ia32 install
mv %{buildroot}/%{_prefix}/lib/*.{lds,o} %{buildroot}/%{_prefix}/lib/gnuefi/
mv ia32/apps/{route80h.efi,modelist.efi} %{buildroot}/boot/efi/EFI/%{efidir}/ia32/
%endif


%files
%{_prefix}/lib*/*
%dir /boot/efi/EFI/%{efidir}/*/
/boot/efi/EFI/%{efidir}/*/*.efi


%files devel
%doc README.*
%{_includedir}/efi


%changelog
* Mon May 27 2024 Pengda Dou <doupengda@loongson.cn> - 3.0.17-3
- [Type] bugfix
- [DESC] fix loongarch64 build error problem

* Wed May 22 2024 Pengda Dou <doupengda@loongson.cn> - 3.0.17-2
- [Type] other
- [DESC] add support for loongarch64

* Thu Dec 21 2023 Upgrade Robot <upbot@opencloudos.org> - 3.0.17-1
- Upgrade to version 3.0.17

* Fri Sep 08 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.11-6
- Rebuilt for OpenCloudOS Stream 23.09

* Wed Aug 9 2023 Shuo Wang <abushwang@tencent.com> - 3.0.11-5
- Build with --no-warn-rwx-segment to fix build error in make apps
- and we don't wind up with segment maps in the final bianries anyway

* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.11-4
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 3.0.11-3
- Rebuilt for OpenCloudOS Stream 23

* Wed Mar 8 2023 Shuo Wang <abushwang@tencent.com> - 3.0.11-2
- update tar ball to 3.0.11

* Tue Jan 31 2023 Shuo Wang <abushwang@tencent.com> - 3.0.11-1
- initial build
